unit TriDLabel;


// Copyright  2001 by Peric , 25.01.2001


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;
   {$R TriDLabel.res}
type
  TTriDLabel = class(TBevel)
private
    { Private declarations }
    FAlignment : TAlignment;
    FCaption : String;
    FFont : TFont;
    FOffset : Byte;

    FOnChange : TNotifyEvent;
     FCop: string;
    function GetCop: string;
    procedure SetCop(const Value: string);
    procedure SetAlignment( taIn : TAlignment );
    procedure SetCaption( const strIn : String);
    procedure SetFont( fntNew : TFont );
    procedure SetOffset( bOffNew : Byte );
  protected
    { Protected declarations }
    constructor Create( compOwn : TComponent ); override;
    destructor Destroy; override;
    procedure Paint; override;
  public
    { Public declarations }
  published
    { Published declarations }
    property Alignment : TAlignment read FAlignment write SetAlignment default taLeftJustify;
    property Caption : String read FCaption write SetCaption;
    property Font : TFont read FFont write SetFont;
    property Offset : Byte read FOffset write SetOffset;
    property OnChange : TNotifyEvent read FOnChange write FOnChange;
    property Copyright: string read GetCop write SetCop;
  end;

procedure Register;

implementation
constructor TTriDLabel.Create;
begin
   inherited Create(compOwn);

   FFont := TFont.Create;
   with compOwn as TForm do
       FFont.Assign(Font);
   Offset := 4;
   Height := 15;
   FCop:='Copyright  2001 by Peric';
end;

destructor TTriDLabel.Destroy;
begin
   FFont.Free;

   inherited Destroy;
end;



 function TTriDLabel.GetCop: string;
begin
  Result:=FCop;
end;

procedure TTriDLabel.SetCop(const Value: string);
begin
  FCop:=FCop;
end;

procedure TTriDLabel.Paint;
var
   wXPos, wYPos : Word;
begin

   {Draw the bevel}
   inherited Paint;

   {Retreive the font}
   Canvas.Font.Assign(Font);

   {Calculate the y position}
   wYPos := (Height - Canvas.TextHeight(Caption)) div 2;

   {Calculate the x position}
   wXPos := Offset;
   case Alignment of
       taRightJustify: wXPos := Width - Canvas.TextWidth(Caption) - Offset;
       taCenter:       wXPos := (Width - Canvas.TextWidth(Caption)) div 2;
   end;
   Canvas.Brush := Parent.Brush;
   Canvas.TextOut(wXPos,wYPos,Caption);
end;

procedure TTriDLabel.SetAlignment;
begin
   FAlignment := taIn;
   Invalidate;
end;

procedure TTriDLabel.SetCaption;
begin
   FCaption := strIn;

   if Assigned(FOnChange) then
       FOnChange(Self);

   Invalidate;
end;

procedure TTriDLabel.SetFont;
begin
   FFont.Assign(fntNew);
   Invalidate;
end;

procedure TTriDLabel.SetOffset;
begin
   FOffset := bOffNew;
   Invalidate;
end;

procedure Register;
begin
  RegisterComponents('PDJ', [TTriDLabel]);
end;

end.
